/* WWW.LABDOMOTIC.COM
 *  La ciabatta Araduino è un progetto realizzato da: Tartaglia Daniele
 *  edstarink@fastwebnet.it
 *  
*/

//Includiamo le due librerire
#include <Keypad.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(13, 12, 5, 4, 3, 2);

//CREAZIONE DEI DUE CARATTERI SPECIALI: Carattere relè acceso e carattere relè spento

byte spento[8] = {
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
};

byte acceso[8] = {
  B11111,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B11111
};


//Creazione delle 6 vriabili con assegnazione pin arduino

int rele1 = 6;
int rele2 = 7;
int rele3 = 8;
int rele4 = 9;
int rele5 = 10;
int rele6 = 11;


//Tastierino numerico

const byte ROWS = 4; //four rows
const byte COLS = 3; //three columns
char keys[ROWS][COLS] = {
  {'1', '2', '3'},
  {'4', '5', '6'},
  {'7', '8', '9'},
  {'*', '0', '#'}
};

byte rowPins[ROWS] = {22, 23, 24, 25}; //connect to the row pinouts of the keypad
byte colPins[COLS] = { 26, 27, 28}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );


// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx  SETUP         xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx



void setup() {
  Serial.begin(9600);


  // IMPOSTA I PIN DA 6 A 11 COME OUTPUT (USATI PER ACCENDERE I RELè DEL MODULO)
  
  pinMode(rele1, OUTPUT);              // Sets the digital pin as output.
  pinMode(rele2, OUTPUT);              // Sets the digital pin as output.
  pinMode(rele3, OUTPUT);              // Sets the digital pin as output.
  pinMode(rele4, OUTPUT);              // Sets the digital pin as output.
  pinMode(rele5, OUTPUT);              // Sets the digital pin as output.
  pinMode(rele6, OUTPUT);              // Sets the digital pin as output.

// IMPOSTA A LIVELLO ALTO I PIN DA 6 A 11 (CONFIGURAZIONE PULL UP)
 
  digitalWrite(rele1, HIGH);           // Turn the LED on.
  digitalWrite(rele2, HIGH);           // Turn the LED on.
  digitalWrite(rele3, HIGH);           // Turn the LED on.
  digitalWrite(rele4, HIGH);           // Turn the LED on.
  digitalWrite(rele5, HIGH);           // Turn the LED on.
  digitalWrite(rele6, HIGH);           // Turn the LED on.


  keypad.addEventListener(keypadEvent); // Add an event listener for this keypad


  
  
  //PRESENTAZIONE 

  
  
  lcd.begin(16, 2); //inizializza display
  lcd.clear(); // fai pulizia del display
  
  // SCRIVI Tartaglia Daniele al primo carattere in alto
  lcd.setCursor(0, 0);
  lcd.print( "Tartaglia Daniele." );
  delay(1000);
  
  lcd.setCursor(0, 1);
  lcd.print( "Presenta:" );
  delay(1000);
  
  lcd.clear();
  delay(1000);
  
  lcd.setCursor(0, 0);
  lcd.print( "Ciabatta Arduino" );
  lcd.setCursor(0, 1);
  lcd.print( "2017 Copyright");
  
  delay(2000);
  lcd.clear();
  
  lcd.print( "Stato rele");
  lcd.clear();
  lcd.setCursor(1, 1);
  lcd.write(1);

  lcd.setCursor(0, 0);
  lcd.print( "Ciabatta arduino");

  
  // Inserisci i simboli che rappresentano lo stato dei relè
 
  lcd.setCursor(1, 1);
  lcd.print( "Stato:");

  lcd.setCursor(8, 1);
  lcd.write(1);

  lcd.setCursor(9, 1);
  lcd.write(1);

  lcd.setCursor(10, 1);
  lcd.write(1);

  lcd.setCursor(11, 1);
  lcd.write(1);

  lcd.setCursor(12, 1);
  lcd.write(1);

  lcd.setCursor(13, 1);
  lcd.write(1);



// Richiama i caratteri speciali

  lcd.createChar(2, acceso);  // Creazione del carattere speciale 1 che mostra o stato acceso del relè
  lcd.createChar(1, spento);  // Creazione del carattere speciale 2 che mostra o stato spento del relè

// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

}

void loop() {
  char key = keypad.getKey();  //la variabile Key assume il valore letto dal tastierno numerico

}


void keypadEvent(KeypadEvent key) {  // in relazione al tasto premuto, si commuterà il case associato.
  switch (keypad.getState()) {
    case PRESSED:
      switch (key) {
        case '1': lcd.setCursor(8, 1);
          lcd.write(2);
          digitalWrite(rele1, LOW); 
          break;
        case '2':
          lcd.setCursor(9, 1);
          lcd.write(2);
          digitalWrite(rele2, LOW);
          break;
        case '3':
          lcd.setCursor(10, 1);
          lcd.write(2);
          digitalWrite(rele3, LOW);
          break;
        case '4':
          lcd.setCursor(11, 1);
          lcd.write(2);
          digitalWrite(rele4, LOW);
          break;
        case '5':
          lcd.setCursor(12, 1);
          lcd.write(2);
          digitalWrite(rele5, LOW);
          break;
        case '6':
          lcd.setCursor(13, 1);
          lcd.write(2);
          digitalWrite(rele6, LOW);
          break;

        // SPEGNIMENTI

        case '7':
          lcd.setCursor(8, 1);
          lcd.write(1); 
          digitalWrite(rele1, HIGH);
          break;
        case '8':
          lcd.setCursor(9, 1);
          lcd.write(1); 
          digitalWrite(rele2, HIGH);
          break;
        case '9':
          lcd.setCursor(10, 1);
          lcd.write(1); 
          digitalWrite(rele3, HIGH);
          break;
        case '*':
          lcd.setCursor(11, 1);
          lcd.write(1); 
          digitalWrite(rele4, HIGH);
          break;
        case '0':
          lcd.setCursor(12, 1);
          lcd.write(1);
          digitalWrite(rele5, HIGH); 
          break;
        case '#':
          lcd.setCursor(13, 1);
          lcd.write(1); 
          digitalWrite(rele6, HIGH);
          break;



      }

    case RELEASED:
      switch (key) {
        case '#':
          // Inserire codice per il rilascio
           
           break;
      }
      break;
    case HOLD:
      switch (key) {
        //case '*': blink = true; 
        // Inserire codice per il manenimento
           
        break;
      }
      break;
  }
}
